package com.jiuqi.util;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.io.OutputStream;

public class StringArrayOutputStream extends OutputStream
{
    private Stream buffer;
    private List list;
    private int line;
    
    public StringArrayOutputStream() {
        this.buffer = new MemStream();
        this.list = new ArrayList();
        this.line = 0;
    }
    
    private void addLine() throws StreamException {
        final byte[] data = this.buffer.getBytes();
        final String s = (data == null) ? "" : new String(data);
        if (this.line >= this.list.size()) {
            this.list.add(s);
        }
        else {
            this.list.set(this.line, s);
        }
        ++this.line;
    }
    
    @Override
    public void write(final int b) throws IOException {
        if (b == 9) {
            return;
        }
        try {
            if (b == 10) {
                this.addLine();
                this.buffer.setSize(0L);
            }
            else {
                this.buffer.write((byte)b);
            }
        }
        catch (final StreamException ex) {
            throw new IOException(ex.getMessage());
        }
    }
    
    public String[] toStringArray() {
        return this.list.toArray(new String[this.list.size()]);
    }
    
    public void reset() {
        this.line = 0;
    }
}
